/*
 * HVIREvent.java
 *
 * Created on December 20, 2004, 11:26 AM
 */

package org.cdp1802.hvision.ir;

/**
 *
 * @author gduprey
 */
public class HVIREvent implements HVIREventI {
  HVIRI theIR = null;
  EventReason theReason;
  int deviceCode, keyCode;
  
  
  HVIREvent(HVIRI theIR, EventReason theReason) {
    this.theIR = theIR;
    this.theReason = theReason;
  }

  HVIREvent(int receivedDeviceCode, int receivedKeyCode, EventReason theReason) {
    this.deviceCode = receivedDeviceCode;
    this.keyCode = receivedKeyCode;
    this.theReason = theReason;
  }
  
  
  public HVIRI getIR() { return theIR; }
  public int getStandardDeviceCode() { return deviceCode; }
  public int getStandardKeyCode() { return keyCode; }
  public EventReason getReason() { return theReason; }
  
  void releaseResources() {
    theIR = null;
  }
  
  public String toString() {
    if (theIR != null) {
      return "KNOWN_IR[" + theIR.getIRNum() + "], EVENT=" + theReason;
    }  else {
      return "STD_IR[DEV=" + deviceCode + ", KEY=" + keyCode + "], EVENT=" + theReason;
    }
  }
}
