/*
 * HVMacro.java
 *
 * Created on December 20, 2004, 11:31 AM
 */

package org.cdp1802.hvision.macro;

import java.util.Collection;
import org.cdp1802.hvision.HVBaseDevice;
import org.cdp1802.xpl.NamedValueI;
import org.cdp1802.xpl.NamedValuesI;
import org.cdp1802.xpl.xPL_MessageI;


/**
 *
 * @author gduprey
 */
public class HVMacro extends HVBaseDevice implements HVMacroI {
  HVMacroManager macroManager = null;
  int macroNum = -1;
  
  HVMacro(HVMacroManagerI theManager, int macroNum) {
    this.macroManager = (HVMacroManager) theManager;
    this.macroNum = macroNum;
    this.ignoreAttrBodyNames = new String[] { "TYPE", "DEVICE", "CURRENT" };
  }

  protected void prepDeviceMessage(String msgItemName, String msgItemValue) {
    if (deviceMessage == null) deviceMessage = getDevice().createBroadcastMessage(xPL_MessageI.MessageType.COMMAND, "control", "advanced");
    deviceMessage.clearMessageBody();
    deviceMessage.addNamedValue("DEVICE", macroNum);
    deviceMessage.addNamedValue("TYPE", "MACRO");
    deviceMessage.addNamedValue(msgItemName, msgItemValue);
  }
  
  public int getMacroNum() { return macroNum; }
  
  public void execute() {
    synchronized(this) {
      prepDeviceMessage("CURRENT", "DO");
      getDevice().sendMessage(deviceMessage);
    }
  }
  
  public void addListener(HVMacroListenerI theListener) {
    macroManager.addListener(theListener, this);
  }
  
  public void removeListener(HVMacroListenerI theListener) {
    macroManager.removeListener(theListener, this);
  }

  void handleMacroXPLEvent(xPL_MessageI theMessage) {
    // Install Attr Values
    if (installAttrs(theMessage.getMessageBody())) {
      macroManager.fireMacroChangedEvent(this, HVMacroEventI.EventReason.ATTR_CHANGED);
    }
  }
  
  public String toString() {
    return String.valueOf(macroNum);
  }
}
