/*
 * TStatEvent.java
 *
 * Created on December 20, 2004, 11:26 AM
 */

package org.cdp1802.tstat;

/**
 *
 * @author gduprey
 */
public class TStatEvent implements TStatEventI {
  TStatI theTStat = null;
  TStatRuntimeI theRuntime = null;
  TStatSchemeI theScheme = null;
  TStatSetpointI theSetpoint = null;
  EventReason theReason;
  
  TStatEvent(TStatI theTStat, EventReason theReason) {
    this.theTStat = theTStat;
    this.theReason = theReason;
  }
  
  TStatEvent(TStatI theTStat, TStatRuntimeI theRuntime, EventReason theReason) {
    this.theTStat = theTStat;
    this.theRuntime = theRuntime;
    this.theReason = theReason;
  }
  
  TStatEvent(TStatI theTStat, TStatSchemeI theScheme, EventReason theReason) {
    this.theTStat = theTStat;
    this.theScheme = theScheme;
    this.theReason = theReason;
  }
  
  TStatEvent(TStatI theTStat, TStatSchemeI theScheme, TStatSetpointI theSetpoint, EventReason theReason) {
    this.theTStat = theTStat;
    this.theScheme = theScheme;
    this.theSetpoint = theSetpoint;
    this.theReason = theReason;
  }

  public TStatI getTStat() { return theTStat; }
  public TStatRuntimeI getRuntime() { return theRuntime; }
  public TStatSchemeI getScheme() { return theScheme; }
  public TStatSetpointI getSetpoint() { return theSetpoint; }
  public EventReason getReason() { return theReason; }
  
  void releaseResources() {
    theTStat = null;
    theRuntime = null;
    theScheme = null;
    theSetpoint = null;
  }
  
  public String toString() {
    return "TSTAT[" + theTStat.getTStatNum() + ":" + theReason.toString() + "] ROOM=" + theTStat.getInsideTemp() + ", SET=" + theTStat.getSetpointTemp();
  }
}
