/*
 * TStatI.java
 *
 * Created on December 22, 2004, 11:04 AM
 */

package org.cdp1802.tstat;


/**
 *
 * @author gduprey
 */
public interface TStatI  {
  public enum TStatMode { OFF, HEAT, COOL, AUTO };
  public enum TStatState { HOLD, RUN };
  public enum FanMode { ON, AUTO };

  public int getTStatNum();

  public int getInsideTemp();
  public int getRemoteTemp();

  public int getSetpointTemp();
  public int getHeatSetpointTemp();
  public int getCoolSetpointTemp();
  
  public TStatMode getMode();
  public void setMode(TStatMode newMode);
  
  public TStatState getState();
  public void setState(TStatState newState);
  
  public FanMode getFanMode();
  public void setFanMode(FanMode newFanMode);
  
  public boolean isRelayLightsMode();
  public void setRelayLightsMode(boolean doRelayLights);
  
  public boolean isLEDLit(int ledNum);
  public void setLEDLit(int ledNum, boolean isLit);
  
  public boolean isHeating();
  public boolean isCooling();
  public boolean isFanRunning();
  
  public TStatRuntimeI getFanRuntime();
  public TStatRuntimeI getHeatingRuntime();
  public TStatRuntimeI getCoolingRuntime();
  
  public int getFilterRuntime();
  
  public TStatSchemeI getInstalledScheme();
  public void setInstalledScheme(TStatSchemeI theScheme);
  public void setInstalledScheme(String schemeName);
  
  public TStatSchemeI getCurrentScheme();
  public TStatSetpointI getCurrentSetpoint();
  
  public int getSchemeCount();
  public TStatSchemeI getSchemeAt(int schemeIndex);
  public TStatSchemeI getSchemeNamed(String schemeName);
  
  public TStatSchemeI createNewScheme(String schemeName);
  public void deleteScheme(String schemeName);
  public void deleteScheme(TStatSchemeI theScheme);
  
  public void addListener(TStatListenerI theListener);
  public void removeListener(TStatListenerI theListener);
}
