/*
 * TStatRuntime.java
 *
 * Created on December 22, 2004, 12:20 PM
 */

package org.cdp1802.tstat;

import org.cdp1802.xpl.xPL_MessageI;

/**
 *
 * @author gduprey
 */
public class TStatRuntime implements TStatRuntimeI {
  int timeToday = 0, timeThisWeek = 0, timeThisMonth = 0;
  int timeThisSeason = 0, timeThisYear = 0, lifetime = 0;
  
  TStatRuntime() { }
  
  public int getToday() { return timeToday; }
  public int getThisWeek() { return timeThisWeek; }
  public int getThisMonth() { return timeThisMonth; }
  public int getThisSeason() { return timeThisSeason; }
  public int getThisYear() { return timeThisYear; }
  public int getLifetime() { return lifetime; }
  
  boolean parseRuntime(xPL_MessageI theMessage, String thePrefix) {
    boolean runtimeChanged = false;
    int newValue = 0;
    
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_TODAY")) != timeToday) {
      timeToday = newValue;
      runtimeChanged = true;
    }
            
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_WEEK")) != timeThisWeek) {
      timeThisWeek = newValue;
      runtimeChanged = true;
    }
    
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_MONTH")) != timeThisMonth) {
      timeThisMonth = newValue;
      runtimeChanged = true;
    }
    
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_SEASON")) != timeThisSeason) {
      timeThisSeason = newValue;
      runtimeChanged = true;
    }
    
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_YEAR")) != timeThisYear) {
      timeThisYear = newValue;
      runtimeChanged = true;
    }
    
    if ((newValue = theMessage.getIntNamedValue(thePrefix + "_LIFETIME")) != lifetime) {
      lifetime = newValue;
      runtimeChanged = true;
    }
    
    return runtimeChanged;
  }
  
}
