/*
 * MutableNamedValue.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl;

/**
 * A named value whoes name and value can be changed.
 *
 * @author  gerry
 */
public class MutableNamedValue extends NamedValue implements MutableNamedValueI {
  MutableNamedValue() {  }
  MutableNamedValue(String theName) {
    this.theName = theName;
  }
  MutableNamedValue(String theName, String theValue) {
    this.theName = theName;
    this.theValue = theValue;
  }

  public void setName(String newName) {
    theName = newName;
  }

  public void setValue(String newValue) {
    theValue = newValue;
  }

  public void setValue(int newValue) {
    theValue = String.valueOf(newValue);
  }

  public void setValue(boolean newValue) {
    theValue = (newValue ? "1" : "0");
  }
}
