/*
 * MutableNamedValueI.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl;

/**
 *
 * @author  gerry
 */
public interface MutableNamedValueI extends NamedValueI {
  /**
   * Install a new name for this named value.
   *
   * @param newName new name for this value
   */
  public void setName(String newName);

  /**
   * Install a new value for this named value.
   *
   * @param newValue new value to install
   */
  public void setValue(String newValue);

  /**
   * Install a new integer value for this named value.
   *
   * @param newValue new integer value to install
   */
  public void setValue(int newValue);

  /**
   * Install a new boolean value for this named value.
   *
   * @param newValue new boolean value to install
   */
  public void setValue(boolean newValue);
}
