/*
 * NamedValue.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl;

/**
 *
 * @author  gerry
 */
public class NamedValue implements NamedValueI {
  String theName = "", theValue = "";
  
  NamedValue() {  }
  NamedValue(String theName) {
    this.theName = theName;
  }
  NamedValue(String theName, String theValue) {
    this.theName = theName;
    this.theValue = theValue;
  }

  public void releaseResources() {
    theName = null;
    theValue = null;
  }
  
  public String getName() { return theName; }
  
  public String getValue() { return theValue; }
  public int getIntValue() {
    // Handle an empty string
    if (theValue.length() == 0) return 0;
    
    try {
      return Integer.parseInt(theValue);
    } catch (Exception anyError) {
      return -1;
    }
  }
  
  public boolean getBoolValue() {
    if (theValue.length() == 0) return false;
    
    if (theValue.length() == 1) {
      char theChar = theValue.charAt(0);
      if ((theChar == 't') || (theChar == 'T') || (theChar == 'y') || (theChar == 'Y') || (theChar == '1')) return true;
      return false;
    }
    
    if (theValue.equalsIgnoreCase("true") || theValue.equalsIgnoreCase("yes")) return true;
    return false;
  }
  
  public String toString() {
    return theName + '=' + theValue;
  }
}
