/*
 * xPL_DeviceChangeEvent.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl.device;

import org.cdp1802.xpl.xPL_IdentifierI;
import org.cdp1802.xpl.xPL_FilterI;

/**
 *
 * @author gduprey
 */
public class xPL_DeviceChangeEvent implements xPL_DeviceChangeEventI {
  xPL_DeviceI theDevice = null;
  ChangeReason changeReason;
  xPL_IdentifierI addedGroup = null;
  xPL_FilterI addedFilter = null;
  xPL_DeviceConfigItemI addedConfigItem = null;
          
  public xPL_DeviceChangeEvent(xPL_DeviceI theDevice, ChangeReason theReason) {
    this.theDevice = theDevice;
    changeReason = theReason;
  }

  public xPL_DeviceChangeEvent(xPL_DeviceI theDevice, ChangeReason theReason, xPL_IdentifierI theGroup) {
    this.theDevice = theDevice;
    changeReason = theReason;
    addedGroup = theGroup;
  }

  public xPL_DeviceChangeEvent(xPL_DeviceI theDevice, ChangeReason theReason, xPL_FilterI theFilter) {
    this.theDevice = theDevice;
    changeReason = theReason;
    addedFilter = theFilter;
  }

  public xPL_DeviceChangeEvent(xPL_DeviceI theDevice, ChangeReason theReason, xPL_DeviceConfigItemI theConfigItem) {
    this.theDevice = theDevice;
    changeReason = theReason;
    addedConfigItem = theConfigItem;
  }

  public ChangeReason getChangeReason() { return changeReason; }

  public xPL_DeviceI getDevice() { return theDevice; }
  

  public xPL_DeviceConfigItemI getConfigItem() { return addedConfigItem; }

  public xPL_FilterI getFilter() { return addedFilter; }

  public xPL_IdentifierI getGroup() { return addedGroup; }
  
  
  void releaseResources() {
    theDevice = null;
    addedGroup = null;
    addedFilter = null;
    addedConfigItem = null;
  }
  
}
