/*
 * xPL_DeviceChangeListenerI.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl.device;

/**
 * Description of a Device Change Listener
 * @author gerry
 */
public interface xPL_DeviceChangeListenerI {
  /**
   * This is fired whenever a significant change to a device occurs.  This includes
   * the device being enabled or disabled, being configured, etc.
   * @param changeEvent description of the change and device change applies toward
   */
  public void handleXPLDeviceChange(xPL_DeviceChangeEventI changeEvent);
}
