/*
 * xPL_DeviceMessageListenerI.java
 * Copyright 2004, Gerald R Duprey Jr
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not
 * use this file except in compliance with the License. You may obtain a copy of
 * the License at
 *
 * http://www.apache.org/licenses/LICENSE-2.0 
 *
 * Unless required by applicable law or agreed to in writing, software distributed
 * under the License is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR
 * CONDITIONS OF ANY KIND, either express or implied. See the License for the
 * specific language governing permissions and limitations under the License. 
 */

package org.cdp1802.xpl.device;

import org.cdp1802.xpl.xPL_MessageI;

/**
 * Description of a device message listener.
 * @author  gerry
 */
public interface xPL_DeviceMessageListenerI {
  
  /**
   * Invoked whenever an xPL message is received and is directed to 
   * this devices listeners.  To be delivered, the message must 
   * either be directly targeted to this device, be directed to a
   * group this sevice is assigned to or be a broadcast message.  If
   * it's a broadcast message and the device has 1 or more filters, the
   * broadcast message must match at least one filter to be delivered.
   *
   * Note: If you want to retain any part of the passed
   * message, you must do it in the message handler as the
   * message object itself will be recycled as soon as 
   * all deliveries of it are complete.
   *
   * @param theDevice device this messagae was directed toward
   * @param theMessage message directed toward the device
   */
  public void handleXPLDeviceMessage(xPL_DeviceI theDevice, xPL_MessageI theMessage);
}
