/*
 * LightingDeviceListenerI.java
 *
 * Copyright (c) 2005, Gerald R Duprey Jr
 * More info at http://www.xPL4Java.org
 */

package org.cdp1802.xpl.lighting;

/**
 * Interface a class implements if it wishes to receive device event messages
 * @author gerry
 */
public interface LightingDeviceListenerI {
  
  /**
   * Invoked whenever an event of interest occurs on a device.  Multiple
   * devices can be monitored with a single listener, so always consult
   * the device specified as part of the event.
   *
   * @param theEvent event describing what just happened
   */
  public void handleLightingDeviceEvent(LightingDeviceEvent theEvent);
}
