/*
 * DeviceAbilityElementOption.java
 *
 * Created on September 28, 2005, 10:06 PM
 *
 */

package org.cdp1802.xpl.plugins;

import java.util.*;
import org.jdom.*;

/**
 *
 * @author gerry
 */
public class DeviceAbilityElementOption extends BasePluginItem {
  DeviceAbilityElementOption() { }
  
  DeviceAbilityElementOption(DeviceAbilityElement parentElement, Element theElement) {
    this.parent = parentElement;
    this.nodeElement = theElement;
  }
  
  DeviceAbilityElementOption(DeviceAbilityElement parentElement, String theLabel, String theValue) {
    this.parent = parentElement;
    this.nodeElement = new Element("option");
    this.nodeElement.setAttribute("value", theValue);
    this.nodeElement.setAttribute("label", theLabel);
  }

  public String getValue() {
    String theText = nodeElement.getAttributeValue("value");
    return (theText == null ? "" : theText);
  }
  
  public void setValue(String newValue) {
    String curValue = getValue();

    if ((newValue == null) || (newValue.length() == 0)) {
      if (curValue.length() != 0) {
        nodeElement.removeAttribute("value");
        markModified();
        fireEvent(PluginEvent.EventCode.OPTION_UPDATED);
      }
      return;
    }
    
    if (curValue.equals(newValue)) return;

    nodeElement.setAttribute("value", newValue);
    markModified();
    fireEvent(PluginEvent.EventCode.OPTION_UPDATED);
  }
  
  public String getLabel() {
    String theText = nodeElement.getAttributeValue("label");
    return (theText == null ? "" : theText);
  }
  
  public void setLabel(String newLabel) {
    String curValue = getLabel();
    
    if ((newLabel == null) || (newLabel.length() == 0)) {
      if (curValue.length() != 0) {
        nodeElement.removeAttribute("label");
        markModified();
        fireEvent(PluginEvent.EventCode.OPTION_UPDATED);
      }
      return;
    }
    
    if (curValue.equals(newLabel)) return;

    nodeElement.setAttribute("label", newLabel);
    markModified();
    fireEvent(PluginEvent.EventCode.OPTION_UPDATED);
  }
  
  public void copyInto(DeviceAbilityElementOption theTarget) {
    boolean setCopiedFrom = (this.copiedFrom != theTarget);
    
    if (setCopiedFrom) theTarget.copiedFrom = this;
    if (theTarget.nodeElement == null) theTarget.nodeElement = new Element(nodeElement.getName());
    
    theTarget.setLabel(getLabel());
    theTarget.setValue(getValue());
  }
    
  public DeviceAbilityElementOption copyOf(DeviceAbilityElement copiesParent) {
    DeviceAbilityElementOption newCopy = new DeviceAbilityElementOption();
    newCopy.parent = copiesParent;
    copyInto(newCopy);
    return newCopy;
  }
  public DeviceAbilityElementOption copyOf() { return copyOf(null); }
}
