/*
 * CreateMessage.java
 *
 * Created on May 31, 2005, 9:58 PM
 */

package org.cdp1802.xpl.script.builtins;

import bsh.*;
import org.cdp1802.xpl.*;

import org.cdp1802.xpl.script.BasicBuiltin;
import org.cdp1802.xpl.script.XPLScript;

/**
 *
 * @author gerry
 */
public class CreateMessage extends BasicBuiltin {
  public static xPL_MutableMessageI invoke(Interpreter env, CallStack callstack, String messageType, String targetDevice, String schemaInfo) {
    // Get the script
    XPLScript theScript = findScript(env);
    if (theScript == null) {
      System.err.println("Unable to locate originating script for CreateMessage() BSH command -- ingored");
      return null;
    }
    
    xPL_MutableMessage newMessage = (xPL_MutableMessage) xPL_Util.createMessage();
    newMessage.setSource(theScript.getDefaultSource());
    if (messageType != null) newMessage.setType(messageType);
    if (targetDevice != null) newMessage.setTarget(targetDevice);
    if (schemaInfo != null) newMessage.setSchema(schemaInfo);
    
    return newMessage;
  }
  
  public static xPL_MutableMessageI invoke(Interpreter env, CallStack callstack, String messageType, String targetDevice) {
    return invoke(env, callstack, messageType, targetDevice, null);
  }
  
  public static xPL_MutableMessageI invoke(Interpreter env, CallStack callstack, String messageType) {
    return invoke(env, callstack, messageType, null, null);
  }
  
  public static xPL_MutableMessageI invoke(Interpreter env, CallStack callstack) {
    return invoke(env, callstack, null, null, null);
  }
}
