/*
 * CreatePeriodicTimer.java
 *
 * Created on June 1, 2005, 11:52 AM
 */

package org.cdp1802.xpl.script.builtins;

import bsh.*;
import org.cdp1802.xpl.*;

import org.cdp1802.xpl.script.PeriodicTimer;
import org.cdp1802.xpl.script.BasicBuiltin;
import org.cdp1802.xpl.script.XPLScript;

/**
 *
 * @author gerry
 */
public class CreatePeriodicTimer extends BasicBuiltin {
  public static PeriodicTimer invoke( Interpreter env, CallStack callstack, int interval, boolean repeating, String handler ) {
    // Get the script
    XPLScript theScript = findScript(env);
    if (theScript == null) {
      System.err.println("Unable to locate originating script for CreatePeriodicTimer() BSH command -- ingored");
      return null;
    }
    
    return theScript.addNewPeriodicTimer(interval, repeating, handler);
  }

  public static PeriodicTimer invoke( Interpreter env, CallStack callstack, int interval, boolean repeating) {
    return invoke(env, callstack, interval, repeating, null);
  }

  public static PeriodicTimer invoke( Interpreter env, CallStack callstack, int interval) {
    return invoke(env, callstack, interval, true, null);
  }
}
