/*
 * CreateScheduledEvent.java
 *
 * Created on June 1, 2005, 2:40 PM
 */

package org.cdp1802.xpl.script.builtins;

import bsh.*;
import org.cdp1802.xpl.*;

import org.cdp1802.xpl.script.BasicBuiltin;
import org.cdp1802.xpl.script.XPLScript;
import org.cdp1802.xpl.script.ScheduledEvent;

/**
 *
 * @author gerry
 */
public class CreateScheduledEvent extends BasicBuiltin {
  public static ScheduledEvent invoke( Interpreter env, CallStack callstack, String timeOfDay, String daysOfWeek, String handler ) {
    // Get the script
    XPLScript theScript = findScript(env);
    if (theScript == null) {
      System.err.println("Unable to locate originating script for CreateScheduledEvent() BSH command -- ingored");
      return null;
    }
    
    return theScript.addNewScheduledEvent(timeOfDay, daysOfWeek, handler);
  }

  public static ScheduledEvent invoke( Interpreter env, CallStack callstack, String timeOfDay, String daysOfWeek) {
    return invoke(env, callstack, timeOfDay, daysOfWeek, null);
  }

  public static ScheduledEvent invoke( Interpreter env, CallStack callstack, String timeOfDay) {
    return invoke(env, callstack, timeOfDay, "All", null);
  }
}
