/*
 * xPL_ManagerEvent.java
 *
 * Created on September 20, 2005, 9:22 AM
 *
 * Describe a xPL manager related event
 */

package org.cdp1802.xpl;

/**
 *
 * @author gerry
 */
public class xPL_ManagerEvent {
  public enum EventCode { MEDIA_HANDLER_ADDED, MEDIA_HANDLER_REMOVED, MEDIA_HANDLER_STARTED, MEDIA_HANDLER_STOPPED,
                          MEDIA_HANDLER_DETECTED_HUB, ALL_HUBS_DETECTED, XPL_SHUTTING_DOWN };
  
  private xPL_MediaHandlerI theHandler = null;
  private EventCode eventCode;
  
  public xPL_ManagerEvent(EventCode theEventCode) {
    eventCode = theEventCode;
  }

  public xPL_ManagerEvent(EventCode theEventCode, xPL_MediaHandlerI theMediaHandler) {
    eventCode = theEventCode;
    theHandler = theMediaHandler;
  }
  
  public EventCode getEventCode() { return eventCode; }
  public xPL_MediaHandlerI getMediaHandler() { return theHandler; }
  
  public void releaseResources() {
    eventCode = null;
    theHandler = null;
  }
}
